<template>
    <div class="container">
        <form v-on:submit.prevent="submit">
            <div class="form-group">
                <label>Projet</label>
                <select class="form-control" type="text" name="project" :required="true" v-model="p" required>
                    <option v-for="project in projects" v-bind:value="project" v-bind:key="project">
                        {{project.title}}
                    </option>
                </select>
            </div>
            <div class="form-group" v-if="p._id">
                <label>Tache</label>
                <select class="form-control" type="text" name="project" v-model="tache.title">
                    <option v-for="task in taches" v-bind:value="task.title" v-bind:key="task.title">
                        {{task.title}}
                    </option>
                </select>
            </div>
            <div class="form-group">
                <label>Commentaire</label>
                <input class="form-control" type="text" name="comment" v-model="tache.comment">
            </div>
            <div class="form-group">
                <label>Date Debut</label>
                <Datepicker input-class="form-control" type="date" name="startdate" :disabled="disabled" :required="true" v-model="tache.start"></Datepicker>
            </div>
            <div class="form-group">
                <label>Date Fin</label>
                <Datepicker input-class="form-control" type="date" name="enddate" :disabled="disabled" :required="true" v-model="tache.end"></Datepicker>
            </div>
            <div class="form-group">
                <button class="btn btn-primary" type="submit"> Sauvegarder </button>
                <button class="btn btn-secondary" type="button" v-on:click="back()"> Retour </button>
            </div>
        </form>
    </div>
</template>

<script>
import Datepicker from 'vuejs-datepicker';
import moment from 'moment';
export default {
    data() {
        return {
            p: {},
            disabled: {
                from: new Date()
            }
        }
    },
    props: ['tache', 'projects'],
    computed: {
        taches() {
            let taches = new Array();
            if (this.p.sprints) {
                this.p.sprints.forEach((s) => {
                    if (s.userStories) {
                        s.userStories.forEach(function(u) {
                            if (u.tasks) {
                                u.tasks.forEach((t) => {
                                    taches.push(t);
                                });
                            }
                        }, this);
                    }
                });
            }
            return taches;
        }
    },
    components: {
        Datepicker
    },
    methods: {
        submit() {
            this.tache.start = moment(this.tache.start).format('YYYY-MM-DD');
            this.tache.end = moment(this.tache.end).format('YYYY-MM-DD');

            if (this.tache.comment) {
                if (this.tache.title) {
                    this.tache.title += " / " + this.tache.comment;
                } else {
                    this.tache.title = this.tache.comment;
                }
            }
            delete this.tache.comment;
            this.$emit('submit', this.tache);
        },
        back() {
            this.$emit('back');
        }
    }
}
</script>

<style>

</style>
